#pragma warn -inl
#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <dos.h>
#include <string.h>
#define MAXDEP 30		// maxima profundidade do stackxy.

// **************************** DATA **************************************

// Variveis globais

unsigned char FB[256];		// buffer de comunicao
char timeout,peeker;
int vez,tiro;
const int dx=25;   		// largura de 1 quadrado
const int dy=25;   		// altura de 1 quadrado
const char linecolor=LIGHTBLUE;
unsigned int COMBASE;		// end.base do hardware da COMn:


// Declaraes de funes

void afxmensage(char*in, int x, int y);
unsigned char process();
void InsertChat(char * user , char * in, unsigned char color );
void PrintChat();
void ReadBytes(unsigned int count);
void SendString(const char *ptr);
void put_io(const unsigned char &byte);
int batota();	// Nao usada na versao Windows...portanto nada de ideias.

// Exit system global function

void exitSys(int errorcode) {
	closegraph();
	clrscr();
	exit(errorcode);
}

void KeyFlush() { // Esvaziar o buffer do stdin ( teclado )
	while(kbhit()) getch();
};


// Declarao da classe QUADRO.


class quadro{
private:
	char matriz[10][10]; 	// Matriz de celulas
	int px,py;              // coord. do quadro na VGA
	int cx,cy;		// coord do cursor

public:
	quadro(int pxi,int pyi); // construtor
	~quadro();       	 //destrutor do objecto
	int exist(char c);	 //retorna 1 se existir no quadro um elem. C
	void setsquare(char x,char y,char c); // Afectar a celula (x,y) com C
	char getsquare(char x,char y); // Obter o quadro (x,y)
	void draw();		 // Desenhar o quadro
	char curx(){return cx;}  // retorno da posio actual do cursor _X.
	char cury(){return cy;}	 //
	char cursor();		 // Processamento do cursor.
	unsigned char identify(char px,char py,char flag=0); // identifica o objecto
private:
	// Desenhar uma celula do quadro.
	void draw_celula(char x, char y, char tipo){
		int ox=px+x*dx;
		int oy=py+y*dy;
		setfillstyle(SOLID_FILL,tipo);
		setcolor(linecolor);
		bar3d(ox,oy+dy,ox+dx,oy,0,1);
	}

	// Pintar  volta da celula , gua-marcada (LIGHTBLUE)

	void MPaint(char px,char py) {
		const int offset[]={-1,-1, -1,0, -1,1, 0,-1, 0,1, 1,-1, 1,0, 1,1 , 2};
		const int * ptr=offset; // apontar ao inicio da tabela.
		int dx,dy,zx,zy;
		while(*ptr!=2) {  // enquanto no chegar ao fim da tabela(val=2)
		    dx=*ptr++;zx=px+dx;
		    dy=*ptr++;zy=py+dy;
		    if(zx<0||zx>9) continue;
		    if(zy<0||zy>9) continue;
		    if(matriz[zx][zy]==BLUE) matriz[zx][zy]=LIGHTBLUE;
		}
	}

}; //class quadro

class pilhaxy{
private:
	int array[MAXDEP]; // Dimenso maxima da pilha
	char ptr;
public:
	pilhaxy(){ ptr=0; }
	void push(char x,char y) {
		if(ptr==MAXDEP) {
			sprintf(FB,"PILHAXY:Stack overflow ao empilhar x: %d y: %d !",x,y);
			afxmensage(FB,10,10);
			process();
			SendString("COMP  Erro de Stack no outro computador. finalize.");
			exitSys(0);
		}
		array[ptr++]=x*0x100+y;
	}
	void pop() { if(ptr) ptr--; }
	char x() {
		char c=array[ptr]/0x0100;
		return c;
	}
	char y() {
		char c=array[ptr]%0x0100;
		return c;
	}
	char empty() { return ptr==0; }
}; // Class Pilhaxy


class rpx{
private:
	int 	rpx[250];
	int 	rpy[250];
	char 	rpc[250];
public:
	rpx(int hh,int hd) {
		for(int a=0;a<250;a++){
			rpx[a]=random(640);
			rpy[a]=hh+random(hd);
			rpc[a]=1+random(15);
		}
	}
	void move(){
		for(int a=0;a<250;a++){
			putpixel(rpx[a],rpy[a],0);
			if((rpx[a]-=rpc[a])<0) rpx[a]+=640;
			putpixel(rpx[a],rpy[a],rpc[a]);
		}
	}
	void clear(){
		for(int a=0;a<250;a++) putpixel(rpx[a],rpy[a],0);
	}
};




// Variaveis globais

quadro meu(40,20);   	// Definio dos quadros.
quadro adv(350,20);
quadro peekC(40,20);



// **************************  CODIGO *************************************


void afxmensage(char*in, int x, int y)
	{
	// caso haja o caractere # substituir por fim de string.
	char * zs;
	for(zs=in;*zs; zs++) if(*zs=='#') { *zs=0;break; }

	int tdx=textwidth("a");
	int tdy=textheight("a")+3;
	int len=strlen(in);
	setcolor(0);
	for(int u=y-3;u<(y+3+tdy);u++) line(0,u,640,u);
	for(char z=1;z<3;z++)
	   {   //border
		setcolor(15);
		moveto(x-z,y-z);
		lineto(x+z+tdx*len,y-z);
		setcolor(7);
		lineto(x+z+tdx*len,y+z+tdy);
		setcolor(BLUE);
		lineto(x-z,y+z+tdy);
		setcolor(LIGHTBLUE);
		lineto(x-z,y-z);
	   }
	moveto(x+1,y+2);
	setcolor(YELLOW);
	outtext(in);
}

void input(int x, int y, char*ptr)
{
   char k=1;
   char *ip=ptr;
   while (k!=13)
   {
     if (k>=32){*ip=k;ip++;*ip=0;}
     if (k==8 && ip!=ptr) {ip--;*ip=0;}

     setcolor(LIGHTGREEN);
     moveto(x,y);
     outtext(ptr);
     setcolor(RED);
     outtext("");
     while(process());// So permitir sair do process com retorno de 0.
     setcolor(8);
     moveto(x,y);
     outtext(ptr);
     outtext("");
     k=getch();
   };
}

void SendMensage() {
	char key[100]="MENSAGE ";
	input(53,470,key+8);
	InsertChat("<ME>",key+8,YELLOW);
	SendString(key);
	PrintChat();
}

// *****************   FUNOES DA CLASSE QUADRO ****************************

quadro::quadro(int pxi,int pyi){
		cx=cy=0;
		px=pxi; py=pyi;
		for(int x=0; x<10;x++)
			for(int y=0; y<10;y++)
				matriz[x][y]=BLUE;
}

quadro::~quadro() { };


int quadro::exist(char c){
	for(int x=0;x<10;x++)
		for(int y=0;y<10;y++)
			if(matriz[x][y]==c)return 1;
	return 0;
}



void quadro::setsquare(char x,char y,char c){
		if(x>10||y>10) return;
		matriz[x][y]=c;
}

char quadro::getsquare(char x,char y){
		return matriz[x][y];
}

void quadro::draw() {
		char s[2]="A";
		int tdx=textwidth(s)+3;
		//int tdy=textheight(s)+3;
		for(char x=0;x<10;x++)
			for(char y=0;y<10;y++){
				draw_celula(x,y,matriz[x][y]);
				if(x==0){
					moveto(px-tdx,py+y*dy+dy/3);
					*s='A'+y;
					outtext(s);
				}
				if(y==0){
					moveto(px+x*dx+dx/3,py+10.2*dy+3);
					*s='0'+x;
					outtext(s);
				}
		       }
}

char quadro::cursor() {
	char k,aux;
	do{
		aux=getsquare(cx,cy);matriz[cx][cy]=WHITE; draw();
		while(process()); // So aceitar retornos de valor 0.
		k=getch();
		if(k=='d') SendMensage();
		matriz[cx][cy]=aux;draw();
		if(k==0){
			k=getch();
			switch(k){
			case 0x48:	//cima
			    if(cy--==0)cy=9;
			    k=0;
			    break;
			case 0x50:	//baixo
			    if(cy++==9)cy=0;
			    k=0;
			    break;
			case 0x4b:	//esquerda
			    if(cx--==0)cx=9;
			    k=0;
			    break;
			case 0x4d:	//direita
			    if(cx++==9)cx=0;
			    k=0;
			    break;
			default:break;
			}   //switch
		 }	    //if
		 }while(!k);
		 return k;
}	//void

/* Funo identify : Retorna o numero de canos do barco apontado em (px,py).
A constante FLAG tem o seguinte significado :

 0 - Verificar somente em relao  cor de fundo (BLUE) - valor por defeito.
 1 - Verificar e apagar no mapa o barco.
 2 - Como em 0 mas s conta com canos = LIGHTRED
 3 - Preencher de gua-marcada  volta dos canos.

*/

unsigned char quadro::identify(char px,char py,char flag) {
	char aux[10][10];
	char x,y,c;
	for(x=0;x<10;x++) for(y=0;y<10;y++) {
		aux[x][y]=matriz[x][y];
		if(aux[x][y]==YELLOW||aux[x][y]==LIGHTBLUE) aux[x][y]=BLUE;

	}
	pilhaxy st;
	char count=0; //inicializar contador.
	if(aux[px][py]==BLUE) return count; // nao pode inciar se for em agua.
	st.push(px,py); // Guardar bloco de entrada.
	do {

		// h existencia de um cano na posio (px,py) ?
		// assim conta-se mais um , destroi-se o cano , empilha-se a
		// posio e depois verifica-se cada lado adjacente.
		if((c=aux[px][py])!=BLUE) {
			st.push(px,py);
			aux[px][py]=BLUE; // marcar como inexistente.
			switch(flag){
				case 1: matriz[px][py]=BLUE;
				case 0: count++; break;
				case 2: if(c==LIGHTRED) count++;
					break;
				case 3: MPaint(px,py);
				default: break;
			}//switch...
		}
		// verificar  esquerda
		if(px>0&&aux[px-1][py]!=BLUE) {px--;continue; }
		// verificar  direita
		if(px<9&&aux[px+1][py]!=BLUE) {px++;continue; }
		// verificar a abaixo
		if(py<9&&aux[px][py+1]!=BLUE) {py++;continue; }
		// verificar a acima
		if(py>0&&aux[px][py-1]!=BLUE) {py--;continue; }
		// Verificar agora a existencia de empilhamentos...
		if(aux[px][py]==BLUE) {
			if(st.empty()) return count;
			st.pop(); 		// desempilha e obter coord.
			px=st.x();py=st.y();
			continue; 		// continuar o ciclo.
		};
	} while(1); // forar o ciclo.



}


// **************************** GLOBALS ************************************

void ExitGame() {
		afxmensage("Desistiu de jogar...Prima tecla ENTER.",10,300);
		SendString("ESC");
		while(getch()!=13);
		exitSys(0);
}

// ***************************  Chat window processes. *********************

#define CHATN 14    // Max lines chat
#define CHATB 13    // Chat insert bottom line

char ch[CHATN][65]; // Memoria array de char para as strings :
		 // a posio ch[n][0] = cor de impresso .
		 // e as restantes ch[n][1..64] = caracteres da string ,
		 // terminando com o caractere '\0' .

void ClrChat() {
	for(int a=0;a<CHATN;a++) *(ch[a]+1)='\0'; // Caractere endof string
}

void InsertChat(char * user , char * in, unsigned char color ) {
	// primeiro "rodar" o texto na memoria ...
	for(int a=0;a<CHATB;a++) strcpy(ch[a],ch[a+1]);
	// inserir o texto _in na memoria.
	// caso haja o caractere # substituir por fim de string.
	char * zs;
	for(zs=in;*zs; zs++) if(*zs=='#') { *zs=0;break; }
	*ch[CHATB]=color;
	strcpy((ch[CHATB]+1),user);
	int len=strlen(user);
	*(ch[CHATB]+len+1)=' ';
	strcpy((ch[CHATB]+2+strlen(user)),in);
}

void PrintChat() {
	// desenhar o quadro
	setcolor(LIGHTRED);
	rectangle(50,320,638,478);
	setcolor(RED);
	rectangle(51,321,639,479);
	setfillstyle(SOLID_FILL,8); // cinza , full-filled.
	bar(52,322,637,477);
	int tdy=textheight("a")+3;
	for(int a=0;a<CHATN;a++) {
	    moveto(53,323+tdy*a);
	    setcolor(*ch[a]);
	    outtext(ch[a]+1);
	}
}

/*
	PROCESS : Processa as mensagens vindas do outro terminal enquanto
		  espera por aco do teclado do computador presente.
		  Esta funo  responsvel pelo tratamento de dados em
		  espera . Deve ter prioridade mxima da execuo , pois o
		  input de dados da COM:  feito em mtodo POLLING.

		  Valores de Retorno :
		  0 	- Foi actuada uma tecla.
		  255	- Foi recebida a mensagem TIRO??* e processada.
		  254	- Foi recebida a mensagem MENSAGE_<...>* e processada.
		  253	- Foi recebida e mensagem READY e processada.
		  252   - Acertou num barco na posio corrente.
		  251	- Afundou um barco na posio corrente.

*/

unsigned char process()
{
   char * stp;
   while (!kbhit())
		      {
		      ReadBytes(255);
		      if (strstr(FB, "READY")) {
			InsertChat("<CPU>","O outro jogador est preparado!!!",15);
			PrintChat();
			vez=0;
			return 253;
		      }
		      if (strstr(FB, "ESC")) {
			afxmensage("O outro jogador desistiu...prima ENTER",10,300);
			while(getch()!=13);
			exitSys(0);
		      }
		      if (strstr(FB, "END")) {
			afxmensage("O outro jogador j era...voc ganhou...Prima ENTER",10,300);
			while(getch()!=13);
			exitSys(0);
		      }
		      if ((stp=strstr(FB, "COMP"))!=NULL) {
			stp+=5;
			InsertChat("<CPU>",stp,RED);
			PrintChat();
			return 251;
		      }
		      if ((stp=strstr(FB, "AFUN"))!=NULL) {
			stp+=5;
			// processamento de amostragem de barco afundado.
			// preencher automaticamente a gua os quadrados
			//  volta do barco afundado.
			adv.identify(adv.curx(),adv.cury(),3); // paint border
			adv.draw();
			InsertChat("<CPU>",stp,LIGHTRED);
			PrintChat();
			return 250;
		      }
		      if ((stp=strstr(FB, "MENSAGE"))!=NULL) {
			stp+=8;//avanar no buffer 8 casas .
			InsertChat("<other>",stp,LIGHTGREEN);
			PrintChat();
			sound(1000);delay(50);nosound();
			return 252;
		      }
		      if((stp=strstr(FB,"PEEK"))!=NULL){
			char x,y,c;
			x=(*(stp+4))-'A';
			for(y=0;y<10;y++) {
				c=meu.getsquare(x,y);
				delay(25);
				put_io(c);
			}
		      }
		      if((stp=strstr(FB,"TIRO"))!=NULL){
			char x,y,c;
			x=(*(stp+4))-'A';
			y=(*(stp+5))-'0';
			c=meu.getsquare(x,y);
			  if(c==BLUE)	{ // AGUA...
				c=LIGHTBLUE; // retornar marca de agua.
				meu.setsquare(x,y,YELLOW);
			  }
			  if(c==LIGHTRED){ // TIRO EM BARCO
				meu.setsquare(x,y,8);  // cinza.
			  }
			meu.draw();
			tiro++;
			put_io(c);
			if(c==LIGHTRED) {
				sound(500);delay(50);
				sound(1000);delay(50);
				sound(1500);delay(50);
				nosound();
				char z[80];
				if(meu.identify(x,y,2)) {
					sprintf(z,
					"COMP Acertou num barco de %c canos.",
					('0'+meu.identify(x,y)));
					SendString(z);
					}
				else {
					sprintf(z,
					"AFUN Afundou um barco de %c canos.",
					('0'+meu.identify(x,y)));
					SendString(z);
				}

			}
			return 255;
		      }
		};
		return 0; // houve uma tecla premida.
}


void criar_tabuleiro(){
	char c=0,aux,x,y,k;
	while(c<25){
		sprintf(FB,"POSICIONE O CANO <%d> de 25.",c+1);
		afxmensage(FB,50,300);
		k=meu.cursor();	//mover para selecionar
		x=meu.curx(); y=meu.cury();
		aux=meu.getsquare(x,y);
		if(k==13){
		if(aux==BLUE){
			meu.setsquare(x,y,LIGHTRED);
			sound(800);
			delay(100);
			nosound();
			c++;
			// Na linha de cdigo seguinte toma-se a ateno
			// de que como o IF  <A> && <B> ( &&=AND LOGICO)
			// o <B> s  processado se <A> for previamente verdadeiro
			// assim se <A> FOR FALSO <B> NAO SER PROCESSADO.
			// logo , a funo batota() s ser chamada se c==25
			// ...se ao contrrio fosse usado um ( || OR LOGICO )
			// ambas as partes teriam de ser evoluidas.
			// assim , para que no se perca tempo , neste caso
			// de condio convm fazer primeiro o C==25.
			if(c==25&& batota()){
					afxmensage("BATOTA...jogo invalido...reposicione.",10,300);
					process();KeyFlush();
					k=83;aux=LIGHTRED;
				}
		 } else
			{
				sound(1500);
				delay(150);
				sound(500);
				delay(300);
				nosound();
			}
		 }//if(k==13)
		 if(k==27)  ExitGame();
		 if(k==83){	//del
			if(aux==LIGHTRED){
				meu.setsquare(x,y,BLUE);
				for(int a=5000; a>500;a-=500){
					sound(a);delay(20);
				}
				nosound();
				c--;
			}//if(aux..
		 }//if(k..
	}//while
	meu.draw();
}//void

// ************************** FUNES DE APOIO DE COMUNICAES SERIE *******

void open_port() { // Define a porta I/O COM1:38400,n,8,1,p
	asm {
	push	dx
	push	ax
	push	bx
	}
	_DX=COMBASE;
	asm{
	push	dx
	add	dx,0x0003
	mov	bx,dx
	mov	al,0x80
	out	dx,al  		//Divisor Latch-enable : BASE+0003
	pop	dx

	mov	al,0x03         //define baud=38400 para o registo do USART
	out	dx,al           //div=115200/baud
	inc	dx
	xor	al,al
	push	dx
	out	dx,al           // BASE+0001

	mov 	dx,bx	       	// No parity + 8bit_lenght + 1stop_bit
	mov	al,0x03
	out	dx,al          	// BASE+0003

	inc	dx  		// BASE+0004
	mov	al,0x03		// RTS,DTS,OUT2=off
	out	dx,al

	pop	dx		// BASE+0001
	xor	al,al
	out	dx,al
	dec	dx
	in	al,dx		// Reset UART

	pop	bx
	pop	ax
	pop	dx
	}

};

unsigned char get_io() { 	// ler um byte do porto serie,se disponivel.
	timeout=0;
	asm {
	push	dx
	push	cx
	push	bx
	}
	_DX=COMBASE;
	asm {
	mov	bx,dx
	add	dx,0x0005
	mov	cx,0x3FFF
	};
get_io_halt:
	asm {
	in	al,dx
	and	al,0x01  	// bit(0)=1 -> Data Ready
	jnz	get_io_read
	dec	cx
	jnz	get_io_halt
	jmp	get_io_timeout
	}
get_io_read:
	asm {
	mov	dx,bx
	in	al,dx
	jmp	get_io_exit
	};
get_io_timeout:
	timeout=0xFF;
get_io_exit:
	asm {
	pop	bx
	pop	cx
	pop	dx
	};
	return _AL;
}

void put_io(const unsigned char &byte) { // Enviar um byte para o porto serie
	_AH=byte;
	asm {
	push	dx
	push	bx
	}
	_DX=COMBASE;
	asm {
	mov	bx,dx
	add	dx,0x0005
	};
put_io_halt:
	asm {
	in	al,dx
	and	al,0x60 // bit(5)=1 -> Trasmitter holder empty.
	xor	al,0x60
	jnz	put_io_halt
	mov	al,ah
	mov	dx,bx
	out	dx,al
	pop	bx
	pop	dx
	};
};


// PING : Esperar pela recepo de UM byte .

char ping(){
	char k;
	do{
		k=get_io();
	}while(timeout);
	return k;
};


void ReadBytes(unsigned int count) {
	asm cli ; // disable external CPU interrupts
	char *wrptr=FB; //point to frameBuffer
	char aux;
	int len;
	if(count>0xFF) {
		puts("O Buffer nao tem espaco disponivel.");
		return;
	};
	while(count>0) {
		if((*wrptr=get_io())=='*') break;//se o caractere recebido
		if(*wrptr=='$') {   // recebido pedido de ACK.
			delay(500); // esperar.
			put_io('&'); // enviar ACK_SIGNAL.
			break;
		}
		if(timeout) break;//for igual a * ou se houver TIMEOUT sair.
		wrptr++;count--;
	};
	*wrptr=0; // close string.
	asm sti ; // enable external CPU interrupts
};

unsigned char evaluate(unsigned char i) { return i==tiro; };

void SendStr(const char *ptr) {
	const char * aux=ptr;
	for(char c=0;c<2;c++,aux=ptr) {
		while(*aux!=0) {
			put_io(*aux);
			aux++;

		}
		put_io('#');
	}
};

void SendString(const char *ptr) {
	SendStr(ptr);
	put_io('*');
}

void SendStringACK(const char *ptr) { // envia e pede reconhecimento.
	char ack;
	for(;;){
		SendStr(ptr);
		put_io('$');	// ACK_request.
		for(unsigned char hlt=1;hlt;hlt++)
			if((ack=get_io())=='&') break;
		if(!timeout&&ack=='&') break; //sucesso.
	}
}

void Getpeek() {
	peeker=1;
	char aux[80],k;
	for(int x=0;x<10;x++) {
		sprintf(aux,"PEEK%c",'A'+x);
		afxmensage(aux,10,300);
		SendStringACK(aux);
		for(int y=0;y<10;y++) {
			k=ping();
			peekC.setsquare(x,y,k);
		}
	peekC.draw();
	}
};



// *************************** BLOCO DE JOGO *******************************

void jogar(){
	char aux[80];
	unsigned char k;
	do{
		if(!meu.exist(LIGHTRED)){
			afxmensage("you loose...finidi",10,300);
			SendStringACK("END");
			return;
		}
		if(vez){
			for(tiro=0;tiro<3;){
				sprintf(aux,"ENVIAR TIRO %d",tiro);
				afxmensage(aux,10,300);
				KeyFlush();
				k=adv.cursor();
				if (k==27) ExitGame();
				if (k=='*'&& evaluate(2) && !peeker) Getpeek();
				if (k=='?'&& peeker) peekC.draw();
				if (k==13) {
					char x,y;
					x=adv.curx();
					y=adv.cury();
					sprintf(aux,"TIRO%c%c",'A'+x,'0'+y);
					SendString(aux);
					k=ping();
					adv.setsquare(x,y,k);tiro++;
					adv.draw();
				}  //if
			}  //for
			vez=0;
		}  //if
		if(vez==0){
			for(tiro=0;tiro<3;){
				sprintf(aux,"A RECEBER o TIRO %d",tiro);
				afxmensage(aux,10,300);
				k=process();
				if(k==0) if((k=getch())=='d') SendMensage();
				if(k==27) ExitGame();
			}  //for
			vez=1;
		}  //if
	}while(1);  //do
}  //void

void Syncronize() {
	rpx a1(0,190);
	rpx a2(220,240);
	do {
		a1.move();
		a2.move();
		SendString("########");
		ReadBytes(255);
		if(strstr(FB,"###")) break; //sincronizado.
		if(kbhit()) if(getch()==27) ExitGame();
	}while(1);
	SendString("###########");
}


int batota(){
	quadro aux(350,20);
	char barco[5];
	char x,y;
	aux.draw();
	for(x=0;x<10;x++)
		for(y=0;y<10;y++)
			aux.setsquare(x,y,meu.getsquare(x,y));
	aux.draw();
	for(x=0;x<5;x++)barco[x]=0;
	for(x=0;x<10;x++)
		for(y=0;y<10;y++)
			if(aux.getsquare(x,y)!=BLUE){
				char z=aux.identify(x,y,1);//conta e apaga
				aux.draw();
				barco[z-1]++;
			} //if
	if(barco[0]!=4)return 1;
	if(barco[1]!=3)return 1;
	if(barco[2]!=2)return 1;
	if(barco[3]!=1)return 1;
	if(barco[4]!=1)return 1;
	return 0;
} //int batota


// ********************** CHAMADA PRINCIPAL DO SIST. OPERATIVO **************

void main() {
	COMBASE=0x03F8;
	nosound();
	unsigned char k;
	ClrChat();
	KeyFlush();
	vez=1;
	int driver=VGA, mode=VGAHI;
	initgraph(&driver,&mode,"");
	afxmensage("A SINCRONIZAR OS COMPUTADORES...AGUARDE QUE O OUTRO JOGADOR EXECUTE...",10,200);
	Syncronize();
	cleardevice();
	meu.draw();
	adv.draw();
	InsertChat("<CPU>","LET THE GAME BEGIN",CYAN);
	PrintChat();
	criar_tabuleiro();
	SendString("READY");
	if(vez==1){
		afxmensage("Aguardar pelo adversario concluir a colocao",10,300);
		do{
			if(!process()) {
				// foi premida uma tecla no process
				if((k=getch())=='d') SendMensage();
				if(k==27) ExitGame();
			}

		}while(vez); // esperar enquanto vez for verdadeiro.
		vez=1;	      // vez ser 1 pois  este computador a jogar primeiro.
	}
	afxmensage("",10,300);
	jogar();
	afxmensage("JOGO TERMINADO...prima ENTER",10,350);
	while(getch()!=13);
	exitSys(0);
}